<template>
    <v-menu
        :value="showMenu"
        @input="hideMenu"
        :position-x="x"
        :position-y="y"
        absolute
        offset-y
    >
        <v-list dense>
            <v-list-item
                v-for="(menuItem, index) in menuItems"
                :key="index"
                selectable
                @click="performAction(menuItem.action)"
            >
                <v-list-item-title>
                    {{ menuItem.title }}
                </v-list-item-title>
            </v-list-item>
        </v-list>
    </v-menu>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api'
import { useContextMenu } from '@/compositions';

export default defineComponent({
    setup() {
        const { 
            performAction,
            setShowMenu,
            getShowMenu: showMenu, 
            getCurrentMenuItems: menuItems, 
            getX: x, 
            getY: y
        } = useContextMenu();

        const hideMenu = () => {
            setShowMenu(false);
        }

        return {
            performAction,
            hideMenu,
            menuItems,
            showMenu,
            x, y
        }
    },
})
</script>
